{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module HROOT.Tree.TTree.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import HROOT.Tree.TTree.RawType
import HROOT.Tree.TTree.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TClass.RawType
import HROOT.Tree.TBranch.RawType

foreign import ccall interruptible "HROOTTreeTTree.h TTree_SetName"
               c_ttree_setname :: Ptr RawTTree -> CString -> IO ()

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_SetNameTitle" c_ttree_setnametitle ::
               Ptr RawTTree -> CString -> CString -> IO ()

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_SetTitle" c_ttree_settitle ::
               Ptr RawTTree -> CString -> IO ()

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_GetLineColor" c_ttree_getlinecolor ::
               Ptr RawTTree -> IO CShort

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_GetLineStyle" c_ttree_getlinestyle ::
               Ptr RawTTree -> IO CShort

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_GetLineWidth" c_ttree_getlinewidth ::
               Ptr RawTTree -> IO CShort

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_ResetAttLine" c_ttree_resetattline ::
               Ptr RawTTree -> CString -> IO ()

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_SetLineAttributes"
               c_ttree_setlineattributes :: Ptr RawTTree -> IO ()

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_SetLineColor" c_ttree_setlinecolor ::
               Ptr RawTTree -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_SetLineStyle" c_ttree_setlinestyle ::
               Ptr RawTTree -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_SetLineWidth" c_ttree_setlinewidth ::
               Ptr RawTTree -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_SetFillColor" c_ttree_setfillcolor ::
               Ptr RawTTree -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_SetFillStyle" c_ttree_setfillstyle ::
               Ptr RawTTree -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_GetMarkerColor" c_ttree_getmarkercolor ::
               Ptr RawTTree -> IO CShort

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_GetMarkerStyle" c_ttree_getmarkerstyle ::
               Ptr RawTTree -> IO CShort

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_GetMarkerSize" c_ttree_getmarkersize ::
               Ptr RawTTree -> IO CFloat

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_ResetAttMarker" c_ttree_resetattmarker ::
               Ptr RawTTree -> CString -> IO ()

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_SetMarkerAttributes"
               c_ttree_setmarkerattributes :: Ptr RawTTree -> IO ()

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_SetMarkerColor" c_ttree_setmarkercolor ::
               Ptr RawTTree -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_SetMarkerStyle" c_ttree_setmarkerstyle ::
               Ptr RawTTree -> CShort -> IO ()

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_SetMarkerSize" c_ttree_setmarkersize ::
               Ptr RawTTree -> CShort -> IO ()

foreign import ccall interruptible "HROOTTreeTTree.h TTree_Clear"
               c_ttree_clear :: Ptr RawTTree -> CString -> IO ()

foreign import ccall interruptible "HROOTTreeTTree.h TTree_Draw"
               c_ttree_draw :: Ptr RawTTree -> CString -> IO ()

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_FindObject" c_ttree_findobject ::
               Ptr RawTTree -> CString -> IO (Ptr RawTObject)

foreign import ccall interruptible "HROOTTreeTTree.h TTree_GetName"
               c_ttree_getname :: Ptr RawTTree -> IO CString

foreign import ccall interruptible "HROOTTreeTTree.h TTree_IsA"
               c_ttree_isa :: Ptr RawTTree -> IO (Ptr RawTClass)

foreign import ccall interruptible "HROOTTreeTTree.h TTree_Paint"
               c_ttree_paint :: Ptr RawTTree -> CString -> IO ()

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_printObj" c_ttree_printobj ::
               Ptr RawTTree -> CString -> IO ()

foreign import ccall interruptible "HROOTTreeTTree.h TTree_SaveAs"
               c_ttree_saveas :: Ptr RawTTree -> CString -> CString -> IO ()

foreign import ccall interruptible "HROOTTreeTTree.h TTree_Write"
               c_ttree_write :: Ptr RawTTree -> CString -> CInt -> CInt -> IO CInt

foreign import ccall interruptible "HROOTTreeTTree.h TTree_Write_"
               c_ttree_write_ :: Ptr RawTTree -> IO CInt

foreign import ccall interruptible "HROOTTreeTTree.h TTree_delete"
               c_ttree_delete :: Ptr RawTTree -> IO ()

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_newTTree" c_ttree_newttree ::
               CString -> CString -> CInt -> IO (Ptr RawTTree)

foreign import ccall interruptible "HROOTTreeTTree.h TTree_Branch"
               c_ttree_branch ::
               Ptr RawTTree -> CString -> CInt -> CInt -> IO CInt

foreign import ccall interruptible "HROOTTreeTTree.h TTree_branch1"
               c_ttree_branch1 ::
               Ptr RawTTree ->
                 CString -> Ptr () -> CString -> CInt -> IO (Ptr RawTBranch)

foreign import ccall interruptible
               "HROOTTreeTTree.h TTree_fillTree" c_ttree_filltree ::
               Ptr RawTTree -> IO CInt
